diff -r f6ef988fda71 trytond/model/modelsql.py
--- a/trytond/model/modelsql.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/model/modelsql.py	Sun Sep 23 17:30:03 2012 +0200
@@ -1596,14 +1586,13 @@
                             target_field = 'rec_name'
                         else:
                             target_field = 'id'
-                        relation_obj = pool.get(field.relation_name)
 
-                        query1, query2 = target_obj.search([
+                        query1, query2 = Target.search([
                                     (target_field, domain[i][1], domain[i][2]),
                                     ], order=[], query_string=True)
                         query1 = ('SELECT ' + select + ' '
                             'FROM ' + table_query +
-                                '"' + relation_obj._table + '" '
+                                '"' + Relation._table + '" '
                             'WHERE "' + field.target + '" IN (' + query1 + ')')
                         query2 = table_args + query2
                         domain[i] = ('id', 'inselect', (query1, query2))
@@ -1613,10 +1602,10 @@
                 # XXX must find a solution for long id list
                 if domain[i][1] in ('child_of', 'not child_of'):
                     if isinstance(domain[i][2], basestring):
-                        field_obj = pool.get(field.model_name)
-                        ids2 = [x[0] for x in field_obj.search([
-                            ('rec_name', 'like', domain[i][2]),
-                            ], order=[])]
+                        Field = pool.get(field.model_name)
+                        ids2 = map(int, Field.search([
+                                    ('rec_name', 'like', domain[i][2]),
+                                    ], order=[]))
                     elif isinstance(domain[i][2], (int, long)):
                         ids2 = [domain[i][2]]
                     else:
@@ -1625,20 +1614,20 @@
                     def _rec_get(ids, table, parent):
                         if not ids:
                             return []
-                        ids2 = table.search([
-                            (parent, 'in', ids),
-                            (parent, '!=', False),
-                            ])
+                        ids2 = map(int, table.search([
+                                    (parent, 'in', ids),
+                                    (parent, '!=', None),
+                                    ]))
                         return ids + _rec_get(ids2, table, parent)
 
-                    if field.model_name != table._name:
+                    if field.model_name != table.__name__:
                         if len(domain[i]) != 4:
                             raise Exception('Error', 'Programming error: '
                                 'child_of on field "%s" is not allowed!'
                                 % domain[i][0])
-                        ids2 = pool.get(field.model_name).search([
-                            (domain[i][3], 'child_of', ids2),
-                            ], order=[])
+                        ids2 = map(int, pool.get(field.model_name).search([
+                                    (domain[i][3], 'child_of', ids2),
+                                    ], order=[]))
                         if domain[i][1] == 'child_of':
                             domain[i] = (domain[i][0], 'in', ids2, table)
                         else:
@@ -1648,7 +1637,7 @@
                             red_sql, red_ids = reduce_ids('id', ids2)
                             cursor.execute('SELECT "' + field.left + '", ' \
                                         '"' + field.right + '" ' + \
-                                    'FROM "' + self._table + '" ' + \
+                                    'FROM "' + cls._table + '" ' + \
                                     'WHERE ' + red_sql, red_ids)
                             clause = '(1=0) '
                             for left, right in cursor.fetchall():
@@ -1658,7 +1647,7 @@
                                         'AND "' + field.right + '" <= ' + \
                                         str(right) + ')'
 
-                            query = 'SELECT id FROM "' + self._table + '" ' + \
+                            query = 'SELECT id FROM "' + cls._table + '" ' + \
                                     'WHERE ' + clause
                             if domain[i][1] == 'child_of':
                                 domain[i] = ('id', 'inselect', (query, []))
@@ -1673,19 +1662,19 @@
                                     ids2, table, domain[i][0]), table)
                 else:
                     if isinstance(domain[i][2], basestring):
-                        field_obj = pool.get(field.model_name)
+                        Field = pool.get(field.model_name)
                         m2o_search = [('rec_name', domain[i][1], domain[i][2])]
-                        if ('active' in field_obj._columns
-                                or 'active' in field_obj._inherit_fields):
+                        if ('active' in Field._fields
+                                or 'active' in Field._inherit_fields):
                             m2o_search += [('active', 'in', (True, False))]
-                        res_ids = field_obj.search(m2o_search, order=[])
+                        res_ids = map(int, Field.search(m2o_search, order=[]))
                         domain[i] = (domain[i][0], 'in', res_ids, table)
                     else:
                         domain[i] += (table,)
                 i += 1
             else:
                 if getattr(field, 'translate', False):
-                    if self._name == 'ir.model':
+                    if cls.__name__ == 'ir.model':
                         table_join = 'LEFT JOIN "ir_translation" ' \
                                 'ON (ir_translation.name = ' \
                                         'ir_model.model||\',%s\' ' \
@@ -1694,7 +1683,7 @@
                                     'AND ir_translation.type = \'model\' ' \
                                     'AND ir_translation.fuzzy = %%s)' % \
                                 domain[i][0]
-                    elif self._name == 'ir.model.field':
+                    elif cls.__name__ == 'ir.model.field':
                         if domain[i][0] == 'field_description':
                             ttype = 'field'
                         else:
@@ -1716,7 +1705,7 @@
                                     'AND ir_translation.lang = %%s ' \
                                     'AND ir_translation.type = \'model\' ' \
                                     'AND ir_translation.fuzzy = %%s)' % \
-                                (table._table, table._name, domain[i][0])
+                                (table._table, table.__name__, domain[i][0])
                     table_join_args = [Transaction().language, False]
 
                     table_query = ''
@@ -1725,10 +1714,10 @@
                         table_query, table_args = table.table_query()
                         table_query = '(' + table_query + ') AS '
 
-                    translation_obj = pool.get('ir.translation')
+                    Translation = pool.get('ir.translation')
 
                     qu1, qu2, tables, table_args = \
-                            translation_obj.search_domain([
+                            Translation.search_domain([
                                 ('value', domain[i][1], domain[i][2]),
                                 ])
                     qu1 = qu1.replace('"ir_translation"."value"',
@@ -1747,8 +1736,8 @@
 
         qu1, qu2 = [], []
         for arg in domain:
-            table = get_model_for_field(self, arg[0])
-            if table == self and len(arg) > 3:
+            table = get_model_for_field(cls, arg[0])
+            if table == cls and len(arg) > 3:
                 table = arg[3]
             column = column_get(table, arg[0])
             if arg[1] in ('inselect', 'notinselect'):
@@ -1887,7 +1876,8 @@
 
         return qu1, qu2
 
-    def _order_calc(self, field, otype):
+    @classmethod
+    def _order_calc(cls, field, otype):
         pool = Pool()
         order_by = []
         tables = []
@@ -1896,25 +1886,25 @@
         table_name = None
         link_field = None
 
-        if field in self._columns:
-            table_name = self._table
+        if field in cls._fields:
+            table_name = cls._table
 
-            if not hasattr(self._columns[field], 'set'):
+            if not hasattr(cls._fields[field], 'set'):
                 field_name = field
 
-            if self._columns[field].order_field:
-                field_name = self._columns[field].order_field
+            if cls._fields[field].order_field:
+                field_name = cls._fields[field].order_field
 
-            if isinstance(self._columns[field], fields.Many2One):
-                obj = pool.get(self._columns[field].model_name)
+            if isinstance(cls._fields[field], fields.Many2One):
+                obj = pool.get(cls._fields[field].model_name)
                 table_name = obj._table
                 link_field = field
                 field_name = None
 
-                if obj._rec_name in obj._columns:
+                if obj._rec_name in obj._fields:
                     field_name = obj._rec_name
 
-                if obj._order_name in obj._columns:
+                if obj._order_name in obj._fields:
                     field_name = obj._order_name
 
                 if field_name:
@@ -1923,7 +1913,7 @@
                     table_join = 'LEFT JOIN "' + table_name + '" AS ' \
                             '"' + table_name + '.' + link_field + '" ON ' \
                             '"%s.%s".id = "%s"."%s"' % (table_name, link_field,
-                                    self._table, link_field)
+                                    cls._table, link_field)
                     for i in range(len(order_by)):
                         if table_name in order_by[i]:
                             order_by[i] = order_by[i].replace(table_name,
@@ -1951,14 +1941,14 @@
 
                 if obj2 and field_name:
                     table_name2 = obj2._table
-                    link_field2 = obj._inherits[obj2._name]
+                    link_field2 = obj._inherits[obj2.__name__]
                     order_by, tables, tables_args = \
                             obj2._order_calc(field_name, otype)
 
                     table_join = 'LEFT JOIN "' + table_name + '" AS ' \
                             '"' + table_name + '.' + link_field + '" ON ' \
                             '"%s.%s".id = "%s"."%s"' % \
-                            (table_name, link_field, self._table, link_field)
+                            (table_name, link_field, cls._table, link_field)
                     for i in range(len(order_by)):
                         if table_name in order_by[i]:
                             order_by[i] = order_by[i].replace(table_name,
@@ -1993,11 +1983,11 @@
                         tables_args[table_join2] = []
                     return order_by, tables, tables_args
 
-            if field_name in self._columns \
-                    and getattr(self._columns[field_name], 'translate', False):
+            if field_name in cls._fields \
+                    and getattr(cls._fields[field_name], 'translate', False):
                 translation_table = 'ir_translation_%s_%s' % \
                         (table_name, field_name)
-                if self._name == 'ir.model':
+                if cls.__name__ == 'ir.model':
                     table_join = 'LEFT JOIN "ir_translation" ' \
                             'AS "%s" ON ' \
                             '("%s".name = "ir_model".model||\',%s\' ' \
@@ -2008,7 +1998,7 @@
                             (translation_table, translation_table, field_name,
                                     translation_table, translation_table,
                                     translation_table, translation_table)
-                elif self._name == 'ir.model.field':
+                elif cls.__name__ == 'ir.model.field':
                     if field_name == 'field_description':
                         ttype = 'field'
                     else:
@@ -2037,9 +2027,9 @@
                                 'AND "%s".type = \'model\' ' \
                                 'AND "%s".fuzzy = %%s)' % \
                             (translation_table, translation_table, table_name,
-                                    translation_table, self._name, field_name,
-                                    translation_table, translation_table,
-                                    translation_table)
+                                translation_table, cls.__name__, field_name,
+                                translation_table, translation_table,
+                                translation_table)
                 if table_join not in tables:
                     tables.append(table_join)
                     tables_args[table_join] = [Transaction().language, False]
@@ -2048,14 +2038,14 @@
                         + '"' + table_name + '".' + field_name + ') ' + otype)
                 return order_by, tables, tables_args
 
-            if field_name in self._columns \
-                    and self._columns[field_name]._type == 'selection' \
-                    and self._columns[field_name].order_field is None:
-                selections = self.fields_get([field_name]
+            if field_name in cls._fields \
+                    and cls._fields[field_name]._type == 'selection' \
+                    and cls._fields[field_name].order_field is None:
+                selections = cls.fields_get([field_name]
                         )[field_name]['selection']
                 if not isinstance(selections, (tuple, list)):
-                    selections = getattr(self,
-                            self._columns[field_name].selection)()
+                    selections = getattr(cls,
+                            cls._fields[field_name].selection)()
                 order = 'CASE ' + table_name + '.' + field_name
                 for selection in selections:
                     order += ' WHEN \'%s\' THEN \'%s\'' % selection
@@ -2074,22 +2064,23 @@
                         % (table_name, field_name, otype))
                 return order_by, tables, tables_args
 
-        if field in self._inherit_fields.keys():
-            obj = pool.get(self._inherit_fields[field][0])
+        if field in cls._inherit_fields.keys():
+            obj = pool.get(cls._inherit_fields[field][0])
             table_name = obj._table
-            link_field = self._inherits[obj._name]
+            link_field = cls._inherits[obj.__name__]
             order_by, tables, tables_args = obj._order_calc(field, otype)
             table_join = 'LEFT JOIN "' + table_name + '" ON ' \
                     '"%s".id = "%s"."%s"' % \
-                    (table_name, self._table, link_field)
+                    (table_name, cls._table, link_field)
             if table_join not in tables:
                 tables.insert(0, table_join)
             return order_by, tables, tables_args
 
         raise Exception('Error', 'Wrong field name (%s) for %s in order!' %
-            (field, self._name))
+            (field, cls.__name__))
 
-    def _rebuild_tree(self, parent, parent_id, left):
+    @classmethod
+    def _rebuild_tree(cls, parent, parent_id, left):
         '''
         Rebuild left, right value for the tree.
         '''
@@ -2097,23 +2088,24 @@
         right = left + 1
 
         with Transaction().set_user(0):
-            child_ids = self.search([
-                (parent, '=', parent_id),
-                ])
+            childs = cls.search([
+                    (parent, '=', parent_id),
+                    ])
 
-        for child_id in child_ids:
-            right = self._rebuild_tree(parent, child_id, right)
+        for child in childs:
+            right = cls._rebuild_tree(parent, child.id, right)
 
-        field = self._columns[parent]
+        field = cls._fields[parent]
 
         if parent_id:
-            cursor.execute('UPDATE "' + self._table + '" ' \
+            cursor.execute('UPDATE "' + cls._table + '" ' \
                     'SET "' + field.left + '" = %s, ' \
                         '"' + field.right + '" = %s ' \
                     'WHERE id = %s', (left, right, parent_id))
         return right + 1
 
-    def _update_tree(self, object_id, field_name, left, right):
+    @classmethod
+    def _update_tree(cls, object_id, field_name, left, right):
         '''
         Update left, right values for the tree.
         Remarks:
@@ -2123,14 +2115,14 @@
         '''
         cursor = Transaction().cursor
         cursor.execute('SELECT "' + left + '", "' + right + '" ' \
-                'FROM "' + self._table + '" ' \
+                'FROM "' + cls._table + '" ' \
                 'WHERE id = %s', (object_id,))
         fetchone = cursor.fetchone()
         if not fetchone:
             return
         old_left, old_right = fetchone
         if old_left == old_right:
-            cursor.execute('UPDATE "' + self._table + '" ' \
+            cursor.execute('UPDATE "' + cls._table + '" ' \
                     'SET "' + right + '" = "' + right + '" + 1 ' \
                     'WHERE id = %s', (object_id,))
             old_right += 1
@@ -2138,42 +2130,42 @@
         parent_right = 1
 
         cursor.execute('SELECT "' + field_name + '" ' \
-                'FROM "' + self._table + '" ' \
+                'FROM "' + cls._table + '" ' \
                 'WHERE id = %s', (object_id,))
         parent_id = cursor.fetchone()[0] or False
 
         if parent_id:
             cursor.execute('SELECT "' + right + '" ' \
-                    'FROM "' + self._table + '" ' \
+                    'FROM "' + cls._table + '" ' \
                     'WHERE id = %s', (parent_id,))
             parent_right = cursor.fetchone()[0]
         else:
             cursor.execute('SELECT MAX("' + right + '") ' \
-                    'FROM "' + self._table + '" ' \
+                    'FROM "' + cls._table + '" ' \
                     'WHERE "' + field_name + '" IS NULL')
             fetchone = cursor.fetchone()
             if fetchone:
                 parent_right = fetchone[0] + 1
 
-        cursor.execute('SELECT id FROM "' + self._table + '" ' \
+        cursor.execute('SELECT id FROM "' + cls._table + '" ' \
                 'WHERE "' + left + '" >= %s AND "' + right + '" <= %s',
                 (old_left, old_right))
         child_ids = [x[0] for x in cursor.fetchall()]
 
         if len(child_ids) > cursor.IN_MAX:
             with Transaction().set_user(0):
-                return self._rebuild_tree(field_name, False, 0)
+                return cls._rebuild_tree(field_name, False, 0)
 
         red_child_sql, red_child_ids = reduce_ids('id', child_ids)
         # ids for left update
-        cursor.execute('SELECT id FROM "' + self._table + '" ' \
+        cursor.execute('SELECT id FROM "' + cls._table + '" ' \
                 'WHERE "' + left + '" >= %s ' \
                     'AND NOT ' + red_child_sql,
                     [parent_right] + red_child_ids)
         left_ids = [x[0] for x in cursor.fetchall()]
 
         # ids for right update
-        cursor.execute('SELECT id FROM "' + self._table + '" ' \
+        cursor.execute('SELECT id FROM "' + cls._table + '" ' \
                 'WHERE "' + right + '" >= %s ' \
                     'AND NOT ' + red_child_sql,
                     [parent_right] + red_child_ids)
@@ -2183,7 +2175,7 @@
             for i in range(0, len(left_ids), cursor.IN_MAX):
                 sub_ids = left_ids[i:i + cursor.IN_MAX]
                 red_sub_sql, red_sub_ids = reduce_ids('id', sub_ids)
-                cursor.execute('UPDATE "' + self._table + '" ' \
+                cursor.execute('UPDATE "' + cls._table + '" ' \
                         'SET "' + left + '" = "' + left + '" + ' \
                             + str(old_right - old_left + 1) + ' ' \
                         'WHERE ' + red_sub_sql, red_sub_ids)
@@ -2191,12 +2183,12 @@
             for i in range(0, len(right_ids), cursor.IN_MAX):
                 sub_ids = right_ids[i:i + cursor.IN_MAX]
                 red_sub_sql, red_sub_ids = reduce_ids('id', sub_ids)
-                cursor.execute('UPDATE "' + self._table + '" ' \
+                cursor.execute('UPDATE "' + cls._table + '" ' \
                         'SET "' + right + '" = "' + right + '" + ' \
                             + str(old_right - old_left + 1) + ' ' \
                         'WHERE ' + red_sub_sql, red_sub_ids)
 
-        cursor.execute('UPDATE "' + self._table + '" ' \
+        cursor.execute('UPDATE "' + cls._table + '" ' \
                 'SET "' + left + '" = "' + left + '" + ' \
                         + str(parent_right - old_left) + ', ' \
                     '"' + right + '" = "' + right + '" + ' \
@@ -2206,21 +2198,21 @@
         # Use root user to by-pass rules
         with contextlib.nested(Transaction().set_user(0),
                 Transaction().set_context(active_test=False)):
-            brother_ids = self.search([
-                (field_name, '=', parent_id),
-                ])
+            brother_ids = map(int, cls.search([
+                        (field_name, '=', parent_id),
+                        ]))
         if brother_ids[-1] != object_id:
             next_id = brother_ids[brother_ids.index(object_id) + 1]
             cursor.execute('SELECT "' + left + '" ' \
-                    'FROM "' + self._table + '" ' \
+                    'FROM "' + cls._table + '" ' \
                     'WHERE id = %s', (next_id,))
             next_left = cursor.fetchone()[0]
             cursor.execute('SELECT "' + left + '" '\
-                    'FROM "' + self._table + '" ' \
+                    'FROM "' + cls._table + '" ' \
                     'WHERE id = %s', (object_id,))
             current_left = cursor.fetchone()[0]
 
-            cursor.execute('UPDATE "' + self._table + '" ' \
+            cursor.execute('UPDATE "' + cls._table + '" ' \
                     'SET "' + left + '" = "' + left + '" + ' \
                             + str(old_right - old_left + 1) + ', ' \
                         '"' + right + '" = "' + right + '" + ' \
@@ -2228,20 +2220,22 @@
                     'WHERE "' + left + '" >= %s AND "' + right + '" <= %s',
                     (next_left, current_left))
 
-            cursor.execute('UPDATE "' + self._table + '" ' \
+            cursor.execute('UPDATE "' + cls._table + '" ' \
                     'SET "' + left + '" = "' + left + '" - ' \
                             + str(current_left - next_left) + ', ' \
                         '"' + right + '" = "' + right + '" - ' \
                             + str(current_left - next_left) + ' ' \
                     'WHERE ' + red_child_sql, red_child_ids)
 
-    def _validate(self, ids):
-        super(ModelSQL, self)._validate(ids)
+    @classmethod
+    def _validate(cls, records):
+        super(ModelSQL, cls)._validate(records)
         cursor = Transaction().cursor
         if cursor.has_constraint():
             return
         # Works only for a single transaction
-        for _, sql, error in self._sql_constraints:
+        ids = map(int, records)
+        for _, sql, error in cls._sql_constraints:
             match = _RE_UNIQUE.match(sql)
             if match:
                 sql = match.group(1)
@@ -2254,18 +2248,18 @@
                     red_sql, red_ids = reduce_ids('id', sub_ids)
 
                     cursor.execute('SELECT id,' + sql + ' ' \
-                            'FROM "' + self._table + '" ' \
+                            'FROM "' + cls._table + '" ' \
                             'WHERE ' + red_sql, red_ids)
 
                     fetchall = cursor.fetchall()
                     cursor.execute('SELECT id ' \
-                            'FROM "' + self._table + '" ' \
+                            'FROM "' + cls._table + '" ' \
                             'WHERE ' + \
                                 ' OR '.join((sql_clause,) * len(fetchall)),
                             reduce(lambda x, y: x + list(y), fetchall, []))
 
                     if cursor.fetchone():
-                        self.raise_user_error(error)
+                        cls.raise_user_error(error)
                 continue
             match = _RE_CHECK.match(sql)
             if match:
@@ -2274,9 +2268,9 @@
                     sub_ids = ids[i:i + cursor.IN_MAX]
                     red_sql, red_ids = reduce_ids('id', sub_ids)
                     cursor.execute('SELECT id ' \
-                            'FROM "' + self._table + '" ' \
+                            'FROM "' + cls._table + '" ' \
                             'WHERE NOT (' + sql + ') ' \
                                 'AND ' + red_sql, red_ids)
                     if cursor.fetchone():
-                        self.raise_user_error(error)
+                        cls.raise_user_error(error)
                     continue
